تستفيد Text Suggestions API من أدوات الذكاء الاصطناعي التوليدي في Product Studio API لإنشاء عناوين المنتجات وأوصافها وتحسينها. يمكنك استخدامها لتحسين تفاعل العملاء ومعدّل الإحالات الناجحة، وتبسيط عملية إدارة معلومات المنتجات وتعديلها. يمكن أن تساعدك ميزات Product Studio API في تحسين أدائك في مجال البيع بالتجزئة.
ما الذي يمكنك إنشاؤه باستخدام واجهة برمجة التطبيقات؟
تساعدك Text Suggestions API في تنفيذ ما يلي:
- عناوين وأوصاف مقترَحة للمنتجات استنادًا إلى صورة المنتج و/أو سمات المنتج
- عناوين محسّنة لمحركات البحث لمنتجاتك
- عناوين منسّقة بشكل مخصّص لمنتجاتك
- أوصاف المنتجات من خلاصة منتجاتك
يمكنك أيضًا تحديد أسلوب الكتابة للأوصاف والحفاظ على الاتساق في جميع بيانات منتجاتك.
التشغيل السريع
يمكن أن تنشئ طريقة GenerateProductTextSuggestions
عناوين المنتجات وأوصافها أو تحسّنها باستخدام معلومات منتجاتك.
تقبل واجهة برمجة التطبيقات ما يلي:
- سمات المنتج (قاموس JSON): كائن JSON يحتوي على سمات المنتج (مثل
{"title": "White Tee", "brand": "MyBrand", "size": "XL"}) - صورة المنتج: عنوان URI يشير إلى صورة المنتج (مثل
{"uri": "https://my-store.com/img/1.png"}) - خيارات تنسيق العنوان: مَعلمات لتخصيص إنشاء العنوان،
بما في ذلك:
attribute_separator: تحدّد الفاصل بين السمات.target_language: تضبط لغة الإخراج.attribute_order: تحدّد ترتيب السمات في العنوان الذي تم إنشاؤه.
- أمثلة على تصنيف البيانات: اطّلِع على مثال حول كيفية إنشاء عنوان من وصف.
- **رقم تعريف سير العمل (
output_spec.workflow_id)**: يحدّد الحقلworkflow_idضمن الكائنoutput_specنوع إنشاء النص:title: ينشئ عنوان المنتج أو يحسّنه.description: ينشئ وصف المنتج أو يحسّنه.tide: ينشئ عنوان المنتج ووصفه أو يحسّنهما معًا.
أمثلة
في ما يلي أمثلة على استخدام واجهة برمجة التطبيقات لإنشاء عنوان أو وصف أو كليهما أو تحسينهما من مدخلات بيانات المنتجات المختلفة. نعرض أيضًا الأخطاء والمشاكل الشائعة وحلولها.
إنشاء عنوان محسَّن
يوضّح المثال كيفية إنشاء عنوان محسّن.
طلب
يحتوي نص الطلب على معلومات المنتج التي سيتم استخدامها لتحسين العنوان. في ما يلي مثال على بنية الطلب:
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Nike Mens shoes",
"description": "Give strength to your step with the Nike Air Zoom Pegasus 38 shoe for Men with shoe size 12. Ensuring the fit is loved by the runners. This shoes comes in Blue color.",
"brand": "Nike"
}
},
"output_spec": {
"workflow_id": "title"
}
}
الردّ
يمكنك توقّع ردّ مثل
{
"title": {
"text": "Nike Mens shoes Air Zoom Pegasus 38 Running Shoes, Blue, Size 12"
},
"metadata": {
"metadata": {
"attributes": {
"color": "Blue",
"size": "12",
"product": "Running shoes",
"model": "Air Zoom Pegasus 38"
},
}
}
}
إنشاء عنوان من صورة فقط
يوضّح المثال كيفية تقديم صورة منتج وإنشاء عنوان محسّن.
طلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_image":{
"uri": "https://cdn.shopify.com/s/files/1/0653/5879/0892/products/1672082339438_550x825.jpg?v=1672082415"
}
},
"output_spec": {
"workflow_id": "title",
"attribute_separator": "-"
}
}
الردّ
{
"title": {
"text": "Rustic Ceramic & Leather Leaves Necklace"
},
"metadata": {
"metadata": {
"attributes": {
"material": "Rustic Ceramic & Leather",
"pattern": "Leaves",
"product": "Necklace"
},
}
}
}
إنشاء عنوان من وصف
يوضّح المثال كيفية تقديم وصف منتج وإنشاء عنوان محسّن.
طلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"description": "selling size 12 nike dunks. oh they are red by the way!"
}
},
"output_spec": {
"workflow_id": "title",
}
}
الردّ
{
"title": {
"text": "Nike Dunks Red Size 12"
},
"metadata": {
"metadata": {
"attributes": {
"brand": "Nike",
"color": "Red",
"size": "12",
"product": "Dunks"
},
}
}
}
تحسين العناوين من عنوان ووصف (بالإضافة إلى مثال مخصّص)
في هذا المثال، نضع علامات بشكل صريح على سمات المنتج التي نريد أن يحدّدها الذكاء الاصطناعي وترتيب السمات في الناتج.
طلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Volumizing & Lengthening Mascara - Dark Brown",
"description": "This high-impact mascara delivers both voluptuous volume and dramatic length without clumping or smudging.",
"brand": "Luxe Beauty"
}
},
"output_spec": {
"workflow_id": "title"
}
"title_examples": [
{
"product_info": {
"title": "Lash Paradise Volumizing & Lengthening Mascara - Waterproof - Blackest Black",
"colour": "Black"
},
"title_format": "product",
"category": "mascara",
"final_product_info": {
"product": "Mascara",
"brand": "Lash Paradise",
"mascara_type": "Volumizing & Lengthening",
"colour": "Blackest Black",
"waterproof": "Waterproof",
}
},
{
"product_info": {
"title": "Hypnose Drama Instant Full Body Volume Mascara - Black",
"colour": "Black"
},
"title_format": "product",
"category": "mascara",
"final_product_info": {
"product": "Mascara",
"brand": "Hypnose",
"sub_brand": "Drama",
"mascara_type": "Full Body Volume",
"colour": "Black",
"eye_lash_type": "All lash types"
}
}
]
}
الردّ
{
"title": {
"text": "Luxe Beauty Dark Brown Volumizing & Lengthening Mascara"
},
"metadata": {
"metadata": {
"attributes": {
"brand": "Luxe Beauty",
"colour": "Dark Brown",
"mascara_type": "Volumizing & Lengthening",
"product": "Mascara"
},
}
}
}
إنشاء وصف من عنوان
يوضّح المثال كيفية تقديم عنوان منتج ومطالبة واجهة برمجة التطبيقات بإنشاء وصف منتج مطابق.
طلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Rustic Ceramic & Leather Leaves Necklace",
}
},
"output_spec": {
"workflow_id": "description"
}
}
الردّ
{
"description": {
"text": "Rustic Ceramic & Leather Leaves Necklace is a beautiful necklace made from high-quality ceramic and leather. It features a unique design that is sure to turn heads.
"
},
}
إنشاء عنوان ووصف من سمات المنتج (مثل العلامة التجارية واللون)
يوضّح هذا المثال كيفية تقديم سمات المنتج لإنشاء عنوان ووصف محسّنين للمنتج.
طلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"brand": "Mr. Beast",
"color": "purple",
},
"product_image":{
"uri": "https://mrbeast.store/cdn/shop/files/0015dlv_0000_327.jpg?v=1702754475&width=500"
}
},
"output_spec": {
"workflow_id": "description"
}
}
الردّ
{
"title": {
"text": "Pajamas - Mr. Beast | Purple"
},
"description": {
"text": "Slip into the ultimate comfort and style with these Mr. Beast pajamas in a vibrant shade of purple. Crafted from the softest materials, these pajamas will envelop you in a cozy embrace, ensuring a restful night's sleep. The shorts feature a relaxed fit, allowing for easy movement, while the top boasts a classic design with a comfortable neckline. Whether you're lounging at home or drifting off to dreamland, these Mr. Beast pajamas are the perfect choice for a peaceful and stylish slumber."
},
}
اللغات الهدف المتاحة
يحدّد هذا الحقل لغة نص الوصف الذي تم إنشاؤه في ردّ واجهة برمجة التطبيقات. يمكنك إضافة target_language كجزء من مَعلمات output_spec:
{
"output_spec": {
"target_language": "language"
}
}
أمثلة على القيم:
"korean" (Korean)
"english" (English)
"spanish" (Spanish)
"french" (French)
مثال على الطلب
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Granos de café negro",
"description": "Los granos de café negro en California",
"brand": "Parfums de Paris",
"scent": "Floral",
},
"product_image":{
"uri": "https://mrbeast.store/cdn/shop/files/0015dlv_0000_327.jpg?v=1702754475&width=500"
}
},
"output_spec": {
"workflow_id": "description",
"target_language": "japanese",
"attribute_order": ["scent", "product"],
"tone": "playful",
}
}
الردّ
{
"description": {
"text": "カリフォルニアの黒いコーヒー豆は、あなたの鼻をくすぐる、甘く、フローラルな香りです。この香りは、コーヒー豆の豊かな香りと、ジャスミンとバラの繊細な花の香りをブレンドしたものです。カリフォルニアの黒いコーヒー豆は、あなたの家を居心地の良いカフェに変え、あなたをリラックスした気分にさせてくれるでしょう。この香りは、コーヒー好きにも、フローラルな香り好きにも最適です。カリフォルニアの黒いコーヒー豆で、あなたの家を幸せな香りで満たしましょう!."
},
}
تخصيص أسلوب الكتابة لإنشاء الوصف
للمساعدة في ترسيخ علامتك التجارية وتمييز متجرك على الإنترنت عن المتاجر الأخرى، يمكنك تخصيص أسلوب الكتابة للأوصاف التي تم إنشاؤها. تقدّم Text API خيارَين:
- اختيار أسلوب الكتابة المحدّد مسبقًا: يمكنك الاختيار من قائمة بأساليب الكتابة لإنشاء أوصاف جديدة. تتضمّن القائمة أساليب الكتابة التالية:
- تلقائي: بسيط وواضح وأنيق
- مرح: خفيف الظل، يستخدم لغة إيجابية وفكاهة (نكات، جناس) ومبالغة (بدون سخرية أو تهكم أو رموز تعبيرية)
- رسمي: اللغة الإنجليزية العادية، والقواعد النحوية الصحيحة، والجمل الكاملة، بدون لغة عامية أو اختصارات
- مقنع: منطقي وموجز ومستند إلى الحجج لإقناع القارئ
- محادثة: ودّي وسهل الفهم ولغة يومية
- أسلوب الكتابة الخاص بالعلامة التجارية: يمكنك تقديم أوصاف حالية أو مواد عرض نصية أخرى بأسلوب كتابة علامتك التجارية. سيحلّل نموذج الذكاء الاصطناعي التوليدي أسلوب الكتابة للنص وينشئ "واصف أسلوب الكتابة" وفقًا لهذه الجوانب:
- الرسمية (مثل رسمي، غير رسمي)
- الإسهاب (مثل موجز، مسهب جدًا)
- أسلوب الكتابة (مثل احترافي، إخباري، إيجابي، مقنع)
- بنية الجملة (مثل "جملة بسيطة تتضمّن عددًا قليلاً من أدوات الربط")
- الكلمات والعبارات الأكثر استخدامًا
مكتبات العملاء
ننصحك باستخدام مكتبات العملاء لإرسال طلباتك. سنشارك معك مكتبات العملاء التي يمكنك تثبيتها في مشروع Maven.
عيّنات تعليمات برمجية
اختَر طريقة المصادقة، واضبط عيّنات التعليمات البرمجية هذه باستخدام هذه الـ تعليمات. في ما يلي عيّنة يمكنك استخدامها لإنشاء اقتراحات نصية.
جافا
import com.google.api.gax.core.FixedCredentialsProvider;
import com.google.auth.oauth2.GoogleCredentials;
import com.google.shopping.merchant.productstudio.v1alpha.GenerateProductTextSuggestionsRequest;
import com.google.shopping.merchant.productstudio.v1alpha.GenerateProductTextSuggestionsResponse;
import com.google.shopping.merchant.productstudio.v1alpha.OutputSpec;
import com.google.shopping.merchant.productstudio.v1alpha.ProductInfo;
import com.google.shopping.merchant.productstudio.v1alpha.TextSuggestionsServiceClient;
import com.google.shopping.merchant.productstudio.v1alpha.TextSuggestionsServiceSettings;
import shopping.merchant.samples.utils.Authenticator;
import shopping.merchant.samples.utils.Config;
/** This class demonstrates how to generate product text suggestions. */
public class GenerateProductTextSuggestionsSample {
private static String getName(String accountId) {
return String.format("accounts/%s", accountId);
}
public static void generateProductTextSuggestions(Config config) throws Exception {
// Obtains OAuth token based on the user's configuration.
GoogleCredentials credential = new Authenticator().authenticate();
TextSuggestionsServiceSettings textSuggestionsServiceSettings =
TextSuggestionsServiceSettings.newBuilder()
.setCredentialsProvider(FixedCredentialsProvider.create(credential))
.build();
String name = getName(config.getAccountId().toString());
// Calls the API and catches and prints any network failures/errors.
try (TextSuggestionsServiceClient textSuggestionsServiceClient =
TextSuggestionsServiceClient.create(textSuggestionsServiceSettings)) {
ProductInfo productInfo =
ProductInfo.newBuilder()
.putProductAttributes("title", "Mens shirt")
.putProductAttributes("description", "A blue shirt for men in size S")
.build();
OutputSpec outputSpec = OutputSpec.newBuilder().setWorkflowId("title").build();
GenerateProductTextSuggestionsRequest request =
GenerateProductTextSuggestionsRequest.newBuilder()
.setName(name)
.setProductInfo(productInfo)
.setOutputSpec(outputSpec)
.build();
System.out.println("Sending GenerateProductTextSuggestions request: " + name);
GenerateProductTextSuggestionsResponse response =
textSuggestionsServiceClient.generateProductTextSuggestions(request);
System.out.println("Generated product text suggestions response below:");
System.out.println(response);
} catch (Exception e) {
System.out.println("An error has occured: ");
System.out.println(e);
}
}
public static void main(String[] args) throws Exception {
Config config = Config.load();
generateProductTextSuggestions(config);
}
}
Python
"""A module to generate product text suggestions."""
from examples.authentication import configuration
from examples.authentication import generate_user_credentials
from google.shopping.merchant_productstudio_v1alpha import GenerateProductTextSuggestionsRequest
from google.shopping.merchant_productstudio_v1alpha import OutputSpec
from google.shopping.merchant_productstudio_v1alpha import ProductInfo
from google.shopping.merchant_productstudio_v1alpha import TextSuggestionsServiceClient
# Fetches the Merchant Center account ID from the configuration file.
# This ID is used to construct the 'name' for the API request.
_ACCOUNT_ID = configuration.Configuration().read_merchant_info()
# The parent resource name for the GenerateProductTextSuggestionsRequest.
# Format: "accounts/{account}"
_PARENT_RESOURCE_NAME = f"accounts/{_ACCOUNT_ID}"
def generate_product_text_suggestions_sample():
"""Generates product text suggestions for a given product."""
# Gets OAuth Credentials.
credentials = generate_user_credentials.main()
# Creates a client for the TextSuggestionsService.
client = TextSuggestionsServiceClient(credentials=credentials)
# Defines the product information for which suggestions are needed.
# This includes attributes like title and description.
product_info = ProductInfo(
product_attributes={
"title": "Mens shirt",
"description": "A blue shirt for men in size S",
}
)
# Defines the output specification.
# The 'workflow_id' specifies the type of text suggestion, e.g., "title".
output_spec = OutputSpec(workflow_id="title")
# Creates the request object for generating product text suggestions.
# It includes the parent resource name, product information, and output
# specification.
request = GenerateProductTextSuggestionsRequest(
name=_PARENT_RESOURCE_NAME,
product_info=product_info,
output_spec=output_spec,
)
# Sends the request to the API.
print(
f"Sending GenerateProductTextSuggestions request: {_PARENT_RESOURCE_NAME}"
)
try:
response = client.generate_product_text_suggestions(request=request)
# Prints the generated suggestions.
print("Generated product text suggestions response below:")
print(response)
except RuntimeError as e:
# Catches and prints any errors that occur during the API call.
print("An error has occured: ")
print(e)
if __name__ == "__main__":
generate_product_text_suggestions_sample()
الأخطاء والمشاكل الشائعة
في ما يلي بعض الأخطاء الشائعة وحلولها.
يجب توفير معلومات المنتج لإنشاء اقتراحات نصية
إذا ظهرت لك رسالة الخطأ التالية
Error message:
"error": {
"code": 400,
"message": "[product_info] Product info is required to generate text suggestions.",
"status": "INVALID_ARGUMENT",
...
}
أضِف product_info في نص الطلب واملأ بشكل صحيح حقلًا واحدًا على الأقل من product_attributes أو product_image.
على سبيل المثال، سيؤدي نشر هذا إلى حدوث خطأ.
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"output_spec": {
"workflow_id": "title"
}
}
يجب ملء حقل واحد على الأقل من `product_info` لإنشاء اقتراحات نصية
يشير هذا الخطأ
{
"error": {
"code": 400,
"message": "[product_info.product_attributes] At least one field of product_info is required to generate text suggestions.",
"status": "INVALID_ARGUMENT",
...
}
إلى أنّه عليك تضمين حقل واحد على الأقل من product_info في نص الطلب.
على سبيل المثال، سيؤدي نشر هذا إلى حدوث خطأ.
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
},
"output_spec": {
"workflow_id": "title"
}
}
استخدِم بدلاً من ذلك ما يلي
"product_info": {
"product_attributes": {
"description": "Selling size 12 Nike dunks. Oh they are red by the way!"
}
}
أو
"product_info": {
"product_image":{
"uri": "https://cdn.shopify.com/s/files/1/0653/5879/0892/products/1672082339438_550x825.jpg?v=1672082415"
}
}
(عنصر) مطلوب في كل `title_example`
تشير الأخطاء مثل الأمثلة الأربعة التالية
{
"error": {
"code": 400,
"message": "[title_examples.product_info] At least one field of product_info is required in each title_example.",
"status": "INVALID_ARGUMENT",
...
}
أو
{
...
"message": "[title_examples.category] Category is required in each title_example.",
...
}
أو
{
...
"message": "[title_examples.title_format] Title format is required in each title_example.",
...
}
أو
{
...
"message": "[title_examples.final_product_info] At least one field of final_product_info is required in each title_example.",
...
}
إلى أنّه لم يتم ملء حقل فرعي مطلوب.
على سبيل المثال، سيؤدي الطلب التالي إلى حدوث خطأ.
POST
https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"description": "selling size 12 nike dunks. oh they are red by the way!"
}
},
"output_spec": {
"workflow_id": "title"
},
"title_examples": []
}
لحلّ هذه المشكلة، املأ جميع الحقول الفرعية التالية لكل `title_example` محدّد في الطلب:
product_infocategorytitle_formatfinal_product_info
في ما يلي مثال يعمل:
{
"product_info": {
"product_attributes": {
"title": "Volumizing & Lengthening Mascara - Dark Brown",
"description": "This high-impact mascara delivers both voluptuous volume and dramatic length without clumping or smudging.",
}
},
"output_spec": {
"workflow_id": "title"
},
"title_examples": [
{
"product_info": {
"title": "Lash Paradise Volumizing & Lengthening Mascara - Waterproof - Blackest Black",
"colour": "Black"
},
"title_format": "product",
"category": "mascara",
"final_product_info": {
"product": "Mascara",
"brand": "Lash Paradise",
"mascara_type": "Volumizing & Lengthening",
"colour": "Blackest Black",
"waterproof": "Waterproof",
}
}
]
}
`workflow_id` غير متاح
سينتج هذا النوع من الأخطاء
{
"error": {
"code": 400,
"message": "[\u003ceye3 title='/ProductStudioTextGenerationService.GenerateProductText, INVALID_ARGUMENT'/\u003e APPLICATION_ERROR; ... ;Unsupported workflow_id: attributes. Supported workflows are: [\"title\", \"description\", \"tide\"];AppErrorCode=3;StartTimeMs=1740696804045;unknown;ResFormat=uncompressed;ServerTimeSec=0.005976589;LogBytes=256;Non-FailFast;EffSecLevel=none;ReqFormat=uncompressed;ReqID=4d1786f59faa3ea7;GlobalID=0;Server=[2002:a05:6e16:618:b0:2c2:7cfc:bebd]:14001] Invalid value",
"status": "INVALID_ARGUMENT",
...
}
عن طلب مثل
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Volumizing & Lengthening Mascara - Dark Brown",
"description": "This high-impact mascara delivers both voluptuous volume and dramatic length without clumping or smudging.",
},
"output_spec": {
"workflow_id": "attributes"
}
}
يضبط الطلب workflow_id على "attributes"، ولكن لا يتيح هذا الحقل سوى إحدى القيم التالية:
- title: ينشئ عنوان المنتج أو يحسّنه.
- description: ينشئ وصف المنتج أو يحسّنه.
- tide: ينشئ عنوان المنتج ووصفه أو يحسّنهما معًا.
أسلوب الكتابة غير متاح
سينتج خطأ "أسلوب الكتابة غير متاح" مثل
{
"error": {
"code": 400,
"message": "[\u003ceye3 title='/ProductStudioTextGenerationService.GenerateProductText, INVALID_ARGUMENT'/\u003e APPLICATION_ERROR; ... ; Unsupported tone: 'asdf'. Supported tones are: [\"default\", \"playful\", \"formal\", \"persuasive\", \"conversational\"];AppErrorCode=3;StartTimeMs=1740697325058;unknown;ResFormat=uncompressed;ServerTimeSec=7.45346E-4;LogBytes=256;Non-FailFast;EffSecLevel=none;ReqFormat=uncompressed;ReqID=f7d9bbbc73a1d342;GlobalID=0;Server=[2002:a05:6918:3486:b0:2bc:ccd4:79e6]:14001] Invalid value",
"status": "INVALID_ARGUMENT",
...
}
عن طلب مثل
POST https://merchantapi.googleapis.com/productstudio/v1alpha/accounts/{ACCOUNT_ID}:generateProductTextSuggestions
{
"product_info": {
"product_attributes": {
"title": "Volumizing & Lengthening Mascara - Dark Brown",
"description": "This high-impact mascara delivers both voluptuous volume and dramatic length without clumping or smudging.",
},
"output_spec": {
"workflow_id": "description"
"tone": "cheerful"
}
}
يُرجى العِلم أنّه يتم ضبط tone على "cheerful"، ولكن لا يتيح هذا الحقل سوى إحدى القيم التالية:
- افتراضي: بسيط وواضح وأنيق
- مرح: خفيف الظل، يستخدم لغة إيجابية وفكاهة (نكات، جناس) و مبالغة (بدون سخرية أو تهكم أو رموز تعبيرية)
- رسمي: اللغة الإنجليزية العادية، والقواعد النحوية الصحيحة، والجمل الكاملة، بدون لغة عامية أو اختصارات.
- مقنع: منطقي وموجز ومستند إلى الحجج لإقناع الـ قارئ.
- conversational: ودّي وسهل الفهم ولغة يومية